{***********************************************
 *                                             *
 *    SAT-Master v1.75 Rotor-Unit AMSAT.PAS    *
 *                                             *
 ***********************************************}
{$A+,L-,R-,S-,I+,F-,O-,N+,E+,L-,V+,B-,M 16384 0 655360}
{*******************************************************************
        UNIT zur Ansteuerung des AMSAT-DL-Rotorinterfaces.
        Dank an Hartmut Psler, DL1YDD
********************************************************************}

unit antenne;
interface

var    amsat     : boolean;
       lpt       : byte;
       druckport : word;
       anschlag  : integer;
       rotor     : array[1..4] of byte;

procedure ant(azimut, elevation:extended);

implementation
               {---ab hier darf geaendert werden---}
uses crt;

procedure byteout(wert:byte);
var bit         : Byte;

begin
  for bit:=1 to 8 do begin
    if (wert and $80)=0 then begin
      port[druckport]:=0;
      delay(0);
      port[druckport]:=2;
      delay(0);
      port[druckport]:=0
    end else begin
      port[druckport]:=1;
      delay(0);
      port[druckport]:=3;
      delay(0);
      port[druckport]:=1
    end;
    delay(0);
    wert:=wert SHL 1
  end
end;

procedure ant(azimut, elevation:extended);
var i : extended;
    j : word;
begin
  if (elevation>-2) and amsat then begin
    i:=elevation/90;
    if rotor[3]>rotor[4] then i:=rotor[4]+(rotor[3]-rotor[4])*i
     else i:=rotor[3]+(rotor[4]-rotor[3])*i;
    j:=round(i);
    if j>255 then j:=j-256;
    byteout(j);             { Vertikal }
    i:=(azimut-anschlag)/360;
    if i<0 then i:=i+1;
    if rotor[1]>rotor[2] then i:=rotor[2]+(rotor[1]-rotor[2])*i
     else i:=rotor[1]+(rotor[2]-rotor[1])*i;
    j:=round(i);
    if j>255 then j:=j-256;
    byteout(j);             { Horizontal }
    port[druckport]:=0
  end
end;


end.
